% Adapt weights

for subnet=1:ninputs
   
   if epochs > outputonlyepochs
      
      if epochs > linearonlyepochs
         z12{subnet} = (1-alpha) * grad12{subnet} + alpha * z12{subnet};
         z23{subnet} = (1-alpha) * grad23{subnet} + alpha * z23{subnet};
         
         eta12up{subnet} = (grad12{subnet} .* grad12old{subnet}) >= 0;
         eta23up{subnet} = (grad23{subnet} .* grad23old{subnet}) >= 0;
         
         eta12{subnet} = eta12{subnet} .* (up * eta12up{subnet} + down * (1 - eta12up{subnet}));
         eta23{subnet} = eta23{subnet} .* (up * eta23up{subnet} + down * (1 - eta23up{subnet}));
         
         weight12{subnet} = weight12{subnet} - eta12{subnet} .* z12{subnet};
         weight23{subnet} = weight23{subnet} - eta23{subnet} .* z23{subnet};
         
         grad12old{subnet} = grad12{subnet};
         grad23old{subnet} = grad23{subnet};
      end
      
      z13{subnet} = (1-alpha) * grad13{subnet} + alpha * z13{subnet};
      eta13up{subnet} = (grad13{subnet} .* grad13old{subnet}) >= 0;
      eta13{subnet} = eta13{subnet} .* (up * eta13up{subnet} + down * (1 - eta13up{subnet}));
      weight13{subnet} = weight13{subnet} - eta13{subnet} .* z13{subnet};
      grad13old{subnet} = grad13{subnet};
      
   end
   
   z34{subnet} = (1-alpha) * grad34{subnet} + alpha * z34{subnet};
   z45{subnet} = (1-alpha) * grad45{subnet} + alpha * z45{subnet};
   z35{subnet} = (1-alpha) * grad35{subnet} + alpha * z35{subnet};
   
   eta34up{subnet} = (grad34{subnet} .* grad34old{subnet}) >= 0;
   eta45up{subnet} = (grad45{subnet} .* grad45old{subnet}) >= 0;
   eta35up{subnet} = (grad35{subnet} .* grad35old{subnet}) >= 0;
   
   eta34{subnet} = eta34{subnet} .* (up * eta34up{subnet} + down * (1 - eta34up{subnet}));
   eta45{subnet} = eta45{subnet} .* (up * eta45up{subnet} + down * (1 - eta45up{subnet}));
   eta35{subnet} = eta35{subnet} .* (up * eta35up{subnet} + down * (1 - eta35up{subnet}));
   
   weight34{subnet} = weight34{subnet} - eta34{subnet} .* z34{subnet};
   weight45{subnet} = weight45{subnet} - eta45{subnet} .* z45{subnet};
   weight35{subnet} = weight35{subnet} - eta35{subnet} .* z35{subnet};
   
   grad34old{subnet} = grad34{subnet};
   grad45old{subnet} = grad45{subnet};
   grad35old{subnet} = grad35{subnet};
end

% If we're using no potential barrier, normalize output weight vectors to norm 1/sqrt(nextra)
%    and set weight35 to zero 

if barrierfact == 0
   for subnet=1:ninputs
      weight45{subnet}(1,1:nextra) = weight45{subnet}(1,1:nextra) / (norm(weight45{subnet}(1,1:nextra)) * sqrt(nextra));
      weight35{subnet} = zeros(size(weight35{subnet}));
   end
end


