% Compute estimated cumulative distributions

% Compute uniform grid for each component

for subnet=1:ninputs
   minimum = min(input3{subnet});
   maximum = max(input3{subnet});
   cgrid{subnet} = minimum:(maximum-minimum)/(ndistr-1):maximum;
end

% Propagate forward in distribution estimation layers

for subnet=1:ninputs
   output3{subnet} = cgrid{subnet};
   output3{subnet}(2,:) = 1;
   input4{subnet} = weight34{subnet} * output3{subnet};
   output4{subnet} = (2/pi) * atan(input4{subnet});
   outputd{subnet} = weight45{subnet} * output4{subnet} + weight35{subnet} * output3{subnet};
end
